;	VGA Monitor Tester
;	(c) 2001 Yuri Lysenkov aka YUSoft yl2@mail.ru http://yl.da.ru
;	based on the Eric Schlaepfer's MDA/CGA Tester schlae@myrealbox.com

;	Ceramic resonator 4MHz, Tcycle=1mkS

;	(VGA: Video mode 640x480  HSync=-31,4KHz 1/HSync=32cycles
;				  VSync=-60Hz 1/VSync=16667cycles

	list p=16c84, f=inhx8m

	#include <P16C84.INC>

	__config  _XT_OSC & _WDT_OFF & _PWRTE_ON

TopCount:	equ	 0x0C
BotCount:	equ	 0x0D
LCount0:	equ	 0x10
LCount1:	equ	 0x11
LCount2:	equ	 0x12
LCount3:	equ	 0x13
LCount4:	equ	 0x14
LCount5:	equ	 0x15
LCount6:	equ	 0x16

#define	Blank	bcf     PORTB, 0
#define Point	bsf     PORTB, 0

HSync:	macro
	bcf     PORTB, 1      ; horiz sync
	nop
	nop                   ; 
	nop                   ; 
	nop                   ; 
	bsf     PORTB, 1      ; horiz sync
	endm

VSync:	macro
	bcf     PORTB, 2 	; vert sync
	nop
	nop
	nop
	nop
	nop
	bsf     PORTB, 2	; vert sync
	endm

	org	0
	goto	Start
	org     0x50            ; start address 0

Start:	clrf    PORTB
	bsf     STATUS, RP0	; select bank 1
	clrf   	TRISB
	bcf     STATUS, RP0	; select bank 0
	bsf     PORTB, 2 	; vert sync

LoopV:	movlw   D'207'
	movwf   TopCount
	movwf   BotCount
	movlw   D'15'
	movwf   LCount0
	movwf   LCount1
	movwf   LCount2
	movwf   LCount3
	movwf   LCount4
	movwf   LCount5
	movwf   LCount6			

	VSync			; 18

				; now, the blank area at the top
BlankLoopTop:
	blank      		; 1
	nop                     ; 2
	nop			; 3
	call    Delay10mkS     	; 4
	call    Delay10mkS     	; 14
	
	HSync                   ; 24

	decfsz  TopCount      	; 29
	goto    BlankLoopTop  	; 30
	nop

Loop0:	blank      ; 4   
	blank      ; 5   
	point      ; 6  * 
	blank      ; 7   
	blank      ; 8   
	point      ; 9  *
	blank      ; 10  
	blank      ; 11  
	blank      ; 12  
	blank      ; 13  
	blank      ; 14  
	blank      ; 15  
	point      ; 16 *
	point      ; 17 *
	point      ; 18 *
	point      ; 19 *
	point      ; 20 *
	blank      ; 21  
	point      ; 22 *
	point      ; 23 *
	point      ; 24 *
	point      ; 25 *
	blank      ; 26  

	HSync

	decfsz  LCount0       ; 30
	goto    Loop0         ; 31
	nop		      ; 32

Loop1:	
	blank      ; 4   
	blank      ; 5   
	point      ; 6  * 
	blank      ; 7   
	blank      ; 8   
	point      ; 9  * 
	blank      ; 10  
	blank      ; 11  
	blank      ; 12  
	blank      ; 13  
	blank      ; 14  
	blank      ; 15  
	point      ; 16 *
	blank      ; 17  
	blank      ; 18  
	blank      ; 19  
	blank      ; 20  
	blank      ; 21  
	blank      ; 22  
	blank      ; 23  
	blank      ; 24  
	point      ; 25 *
	blank      ; 26  

	HSync

	decfsz  LCount1       ; 30
	goto    Loop1         ; 31
	nop		      ; 32

Loop2:	blank      ; 4   
	blank      ; 5   
	point      ; 6 * 
	blank      ; 7   
	blank      ; 8   
	point      ; 9 * 
	blank      ; 10  
	blank      ; 11  
	blank      ; 12  
	point      ; 13 *
	blank      ; 14  
	blank      ; 15  
	point      ; 16 *
	blank      ; 17  
	blank      ; 18  
	blank      ; 19  
	blank      ; 20  
	blank      ; 21  
	blank      ; 22  
	blank      ; 23  
	blank      ; 24  
	point      ; 25 *
	blank      ; 26  

	HSync

	decfsz  LCount2       ; 30
	goto    Loop2         ; 31
	nop		      ; 32

Loop3:	blank      ; 4   
	blank      ; 5   
	point      ; 6 * 
	point      ; 7 * 
	point      ; 8 * 
	point      ; 9 * 
	point      ; 10 *
	blank      ; 11  
	blank      ; 12  
	blank      ; 13  
	blank      ; 14  
	blank      ; 15  
	point      ; 16 *
	point      ; 17 *
	point      ; 18 *
	point      ; 19 *
	blank      ; 20  
	blank      ; 21  
	blank      ; 22  
	blank      ; 23  
	blank      ; 24  
	point      ; 25 *
	blank      ; 26  

	HSync

	decfsz  LCount3       ; 30
	goto    Loop3         ; 31
	nop		      ; 32

Loop4:	blank      ; 4   
	blank      ; 5   
	blank      ; 6   
	blank      ; 7   
	blank      ; 8   
	point      ; 9 * 
	blank      ; 10  
	blank      ; 11  
	blank      ; 12  
	point      ; 13 *
	blank      ; 14  
	blank      ; 15  
	blank      ; 16  
	blank      ; 17  
	blank      ; 18  
	blank      ; 19  
	point      ; 20 *
	blank      ; 21  
	blank      ; 22  
	blank      ; 23  
	blank      ; 24  
	point      ; 25 *
	blank      ; 26  

	HSync

	decfsz  LCount4       ; 30
	goto    Loop4         ; 31
	nop		      ; 32

Loop5:	blank      ; 4   
	blank      ; 5   
	blank      ; 6   
	blank      ; 7   
	blank      ; 8   
	point      ; 9 * 
	blank      ; 10  
	blank      ; 11  
	blank      ; 12  
	blank      ; 13  
	blank      ; 14  
	blank      ; 15  
	point      ; 16 *
	blank      ; 17  
	blank      ; 18  
	blank      ; 19  
	point      ; 20 *
	blank      ; 21  
	blank      ; 22  
	blank      ; 23  
	blank      ; 24  
	point      ; 25 *
	blank      ; 26  

	HSync

	decfsz  LCount5       ; 30
	goto    Loop5         ; 31
	nop		      ; 32

Loop6:	blank      ; 4   
	blank      ; 5   
	blank      ; 6   
	blank      ; 7   
	blank      ; 8   
	point      ; 9 * 
	blank      ; 10  
	blank      ; 11  
	blank      ; 12  
	blank      ; 13  
	blank      ; 14  
	blank      ; 15  
	blank      ; 16  
	point      ; 17 *
	point      ; 18 *
	point      ; 19 *
	blank      ; 20  
	blank      ; 21  
	blank      ; 22  
	blank      ; 23  
	blank      ; 24  
	point      ; 25 *
	blank      ; 26  

	HSync
	
	decfsz  LCount6       ; 30
	goto    Loop6         ; 31
	nop                   ; 32
	
			      ;now, the blank area at the bottom
BlankLoopBot:
	blank      	      ; 1
	nop                   ; 2
	nop		      ; 3
	call    Delay10mkS    ; 4
	call    Delay10mkS    ; 14
	
	HSync		      ; 24

	decfsz  BotCount      ; 29
	goto    BlankLoopBot  ; 30

	goto    LoopV

Delay10mkS:
	nop
	nop
	nop
	nop
	nop
	nop
	return

	end
